var _files = [];
var _urls = [];
var _pages = [];
var page_index;
var page_id;
var video_id;
var video_title;
var video_link;
var video_duration;
var video_poster;
var video_tags;
var video_config;
window.onerror = function(error) {
    console.log(error);
    if(error.indexOf('ResizeObserver')>-1) return;
    analytics_get(['popup','error',error]);
};
var language;
if (window.navigator.languages) {
    language = window.navigator.languages[0];
} else {
    language = window.navigator.userLanguage || window.navigator.language;
}
console.log(language);
if(language.indexOf('zh') == -1 && language.indexOf('-') > -1){
    var language = language.split('-')[0];
}
function icon(quality){
    quality = quality.toLowerCase();
    var svg = '';
    if(quality=='2160p') svg = 'q4k';
    else if(quality=='1080p') svg = 'q1080';
    else if(quality=='720p') svg = 'q720';
    else if(quality=='auto') svg = 'downloadsmile';
    else if(quality=='comment') svg = 'comment';
    else if(quality=='mp4') svg = 'downloadsmile';
    else if(quality.indexOf('flv')>-1) svg = 'flv';
    else if(quality.indexOf('kbps')>-1) svg = 'audio';
    return svg;
}
function template_link(o,a){
    var links = '';
    for (var i = 0; i < a.length; i++) {
        var s = a[i];
        var template = $('#template_link').val();
        var svg = icon(s.format);
        if(svg == '') var ic = '<div>'+s.format+'</div>';
        else var ic = '<img src="img/'+svg+'.svg">';
        template = template.replace('{icon}',ic);
        var url = (s.url!=undefined)?s.url:s.stream;
        var b = o;
        b.download = s.format;
        template = template.replace('{lang}',language);
        template = template.replace('{json}',JSON.stringify(b).replace(/"/g,'%22'));
        template = template.replace('{quality}',s.format);
        links += template;
        if(i==5 || a.length-1 == i){
            var template = $('#template_link').val();
            template = template.replace('{icon}','<img src="img/threedots.svg">');
            template = template.replace('{lang}',language);
            o.download = '';
            template = template.replace('{json}',JSON.stringify(o).replace(/"/g,'%22'));
            template = template.replace('{quality}',s.format);
            links += template;
        }
    }
    return links;
}
function template_video(a){
    var template = $('#template_video').val();
    template = template.replace('{title}',a.title);
    template = template.replace(/{link}/g,a.link);
    var links = template_link(a,a.streams)+template_link(a,a.formats);
    template = template.replace(/{links}/g,links);
    var images = [];
    for(var img in a.thumbnails) {
        images.push(a.thumbnails[img]);
    }
    var thumbnail_data = {
        images: images,
        u: a.link,
        full: 1
    };
    template = template.replace('{thumbnail_data}',JSON.stringify(thumbnail_data).replace(/"/g,'%22'));
    var bg = a.poster;
    template = template.replace(/{background}/g,bg);
    template = template.replace(/{lang}/g,language);
    return template;
}
function sort_quality(a, b) {
    aq = parseInt(a.quality);
    af = a.fps;
    bq = parseInt(b.quality);
    bf = b.fps;
    if (aq === bq) {
        if (af === bf) {
            return 0;
        } else if (af < bf) {
            return -1;
        } else {
            return 1;
        }
    } else if (aq < bq) {
        return -1;
    } else {
        return 1;
    }
}
function showDownloads(callback_data){
    var video = template_video(callback_data);
    $('#videos').prepend(video);
    $('#loading').css('display','none');
    if(!localStorage.download1click) localStorage.download1click = 'off';
    if(localStorage.download1click=='on'){
        if(!localStorage.automaticselection) localStorage.automaticselection = 'max';
        var o = request.data;
        if(localStorage.automaticselection=='max'){
            if(request.data.streams.length > 0) o.download = request.data.streams[0].format;
            else if(request.data.formats.length > 0) o.download = request.data.formats[0].format;
        }
        else {
            o.download = localStorage.automaticselection;
        }
        chrome.tabs.create({
            url: 'https://fbion.com/'+language+'/bilibili-downloader.html#data='+JSON.stringify(o)
        });
    }
}
function bytesToSize(bytes) {
    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
    if (bytes == 0) return '0 Byte';
    var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
    var n = Math.round(bytes / Math.pow(1024, i), 2);
    return n + ' ' + sizes[i];
}
function video_info(videoid,pageid,callback_data){
    video_config = "https://api.bilibili.com/x/web-interface/view?aid="+videoid+"&cid="+pageid;
    loader(video_config,callback_data);
}
function parsedata(o,callback_data) {
    if(callback_data!=''){
        if(o.data.durl!=undefined){
            var index = 0;
            o.data.durl.forEach(function(e) {
                if(index >= o.data.accept_description.length) index = o.data.accept_description.length - 1;
                var q = o.data.accept_description[index].split(' ')[1];
                if(o.data.durl.length==1) q = o.data.format;
                var f = {
                    format: q,
                    info: 'FLV '+bytesToSize(e.size),
                    url: e.url.replace('http://','https://')
                }
                callback_data.formats.unshift(f);
                index++;
            });
            video_info(video_id,page_id,callback_data);
        }
        return;
    }
    callback_data = {
        sorted: 1,
        title: '',
        formats: [],
        streams: [],
        link: ''
    };
    if(o.data.dash!=undefined){
        callback_data.duration = o.data.dash.duration;
        o.data.dash.video.forEach(function(e) {
            var q = (e.height<e.width)?e.height:e.width;
            var f = {
                format: q+'p',
                info: 'mute 🔇 '+bytesToSize(e.bandwidth),
                url: e.baseUrl.replace('http://','https://')
            }
            callback_data.formats.push(f);
        });
        o.data.dash.audio.forEach(function(e) {
            var bitrate = parseInt(e.bandwidth/1000);
            if(bitrate >= 320) bitrate = 320;
            else if(bitrate >= 256) bitrate = 256;
            else if(bitrate >= 192) bitrate = 192;
            else if(bitrate >= 128) bitrate = 128;
            else if(bitrate >= 64) bitrate = 64;
            var f = {
                format: bitrate+'kbps',
                info: 'audio 🔊',
                url: e.baseUrl.replace('http://','https://')
            }
            callback_data.formats.push(f);
        });
    }

    var index = 0;
    if(o.data.durl!=undefined){
        o.data.durl.forEach(function(e) {
            var q = "Live";
            if(o.data.accept_description!=undefined){
                if(index >= o.data.accept_description.length) index = o.data.accept_description.length - 1;
                q = o.data.accept_description[index].split(' ')[1];
            }
            if(o.data.durl.length==1) q = o.data.format;
            var f = {
                format: q,
                info: 'FLV '+bytesToSize(e.size),
                url: e.url.replace('http://','https://')
            }
            callback_data.formats.push(f);
            index++;
        });
    }
    try{
        page_id = callback_data.formats[0].url.split('/')[6];
        callback_data.id = page_id;
        callback_data.title = video_title;
        callback_data.link = video_link;
        callback_data.poster = video_poster;
        callback_data.tags = video_tags;
        callback_data.thumbnails = [];
        //callback_data.thumbnails.push("https://i0.hdslb.com/bfs/videoshot/"+page_id+".jpg");
        callback_data.preview = 'https://player.bilibili.com/player.html?aid='+video_id+'&cid='+page_id+'&page='+(page_index+1);
    } catch(err){}
    if(page_id==undefined && callback_data.link.indexOf('live.bilibili.com') > -1) page_id = video_id;
    var f = {
        format: 'comment',
        url: 'https://comment.bilibili.com/'+page_id+'.xml'
    }
    callback_data.formats.push(f);
    if(callback_data.formats[0].url.indexOf('live-play') > -1){
        chrome.runtime.sendMessage({action: "add",data: callback_data});
        showDownloads(callback_data);
        return;
    }
    if(o.data.durl==undefined){
        video_config = "https://api.bilibili.com/x/player/playurl?platform=pc&otype=json&avid="+video_id+"&cid="+page_id+"&qn=112&type=";
        loader(video_config,callback_data);
        return;
    }
    else{
        video_info(video_id,page_id,callback_data);
    }
}
function loader(url,callback_data){
    console.log('load url '+url);
    var xhttp = new XMLHttpRequest();
    xhttp.open('GET', url);
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState === XMLHttpRequest.DONE) {
            if (xhttp.status === 200) {
                var o = JSON.parse(xhttp.responseText);
                console.log(o);
                if(url.indexOf('pagelist') > -1){
                    _pages = o.data;
                    page_id = _pages[page_index].cid;
                    video_title = _pages[page_index].part+' '+video_title;
                    video_duration = _pages[page_index].duration;
                    video_config = "https://api.bilibili.com/x/player/playurl?avid="+video_id+"&cid="+page_id+"&qn=112&type=&otype=json&fnver=0&fnval=16&session=";
                    loader(video_config,callback_data);
                }
                else if(url.indexOf('Room/playUrl') > -1){
                    parsedata(o,callback_data);
                }
                else if(url.indexOf('playurl') > -1){
                    parsedata(o,callback_data);
                }
                else if(url.indexOf('web-interface/view') > -1){
                    callback_data.title = o.data.pages[page_index].part+' '+o.data.title;
                    callback_data.duration = o.data.duration;
                    callback_data.poster = o.data.pic.replace('http://','https://');
                    callback_data.thumbnails.unshift(callback_data.poster);
                    callback_data.thumbnails.push(o.data.owner.face.replace('http://','https://'));
                    if(o.data.subtitle!=undefined){
                        if(o.data.subtitle.list.length > 0){
                            callback_data.subtitles = [];
                            for (var k = 0; k < o.data.subtitle.list.length; k++) {
                                callback_data.subtitles.push({
                                    label: o.data.subtitle.list[k].lan_doc,
                                    urls: [o.data.subtitle.list[k].subtitle_url.replace('http://','https://')]
                                });
                            }
                        }
                    }
                    loader('https://api.bilibili.com/x/player/videoshot?aid='+video_id+'&cid='+page_id+'&jsonp=jsonp',callback_data);
                }
                else if(url.indexOf('videoshot') > -1){
                    if(o.data.image!=undefined){
                        if(o.data.image.length > 0){
                            for (var k = 0; k < o.data.image.length; k++) {
                                callback_data.thumbnails.push('https:'+o.data.image[k]);
                            }
                        }
                    }
                    chrome.runtime.sendMessage({action: "add",data: callback_data});
                    showDownloads(callback_data);
                    //console.log(callback_data);
                }
            } else {
                console.log('ajax fail '+xhttp.statusText+' '+url);
            }
        }
    };
    xhttp.send();
}
function rw(){
    if(navigator.userAgent.indexOf('Android') == -1) return;
    var zoom = window.screen.width/400;
    $('body').css('zoom', zoom);
    $('body').css('-moz-transform', 'scale('+zoom+')');
    var h1 = $('#header').outerHeight(true);
    var hm = $('#menu').outerHeight(true);
    var hs = $('#scroll').outerHeight(true);
    var ho = $('#scroll').height();
    var h = window.screen.height - h1 - hm - 22;
    if(h < 450) h = 450;
    //var h = window.innerHeight - document.body.scrollHeight;
    $('#scroll').height(h);
    $('#screen').text(window.screen.width+'x'+window.screen.height);
}
window.addEventListener("load", function() {
    rw();
    window.addEventListener('resize', function () {
        rw();
    });
    chrome.tabs.insertCSS({
        file: 'bilibili_player.css',
        allFrames: true
    },
    function() {
        if(chrome.runtime.lastError!=undefined) {
            $('#onlybilibili').css('display','block');
            $('#loading').css('display','none');
            return;
        }
        chrome.tabs.executeScript({
            file: 'bilibili.js',
            allFrames: true
        },
        function(response) {
            //console.log(response);
            if(response==undefined){
                $('#loading').css('display','none');
                return;
            }
            var message = '';
            var done = false;
            response.forEach(function(result) {
                if (result.status === 'loader_processing') {
                    message = 'Processing...';
                } else if (result.status === 'loader_done') {
                    message = 'Done!';
                    done = true;
                } else if (result.status === 'buttons_added') {
                    message = 'Added!';
                    done = true;
                } else if (result.status === 'player_undefined') {
                    message = 'Added!';
                    done = true;
                } else if (result.status === 'script_undefined') {
                    message = 'Added!';
                    done = true;
                }
                return;
            });
            if(done) $('#loading').css('display','none');
        })
    });
    setTimeout(function(){
        chrome.runtime.sendMessage({action: "getData"}, function(response) {
            //console.log(response);
            _files = response.data;
            var no = 0;
            for (var i = _files.length - 1; i >= 0; i--) {
                no++;
                var video = template_video(_files[i]);
                $('#videos').append(video);
                if(no==2 || no == _files.length){
                    var expire = '<p class="_text_expire" style="color:red;font-weight:bold;font-size:16px;">⚠ '+$('#expire_message').text()+'</p>';
                    $('#videos').append(expire);
                }
            }
        });
    },300);
});

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.action == "parse")
    {
        video_id = request.id;
        video_title = request.title;
        video_link = request.link;
        video_poster = request.poster;
        video_tags = request.tags;
        page_index = request.index - 1;
        parsedata(request.data,'');
    }
    else if (request.action == "done"){
        $('#loading').css('display','none');
    }
    else if (request.action == "loader"){
        $('#loading').css('display','block');
        var page_config = 'https://api.bilibili.com/x/player/pagelist?aid='+request.id+'&jsonp=jsonp';
        video_id = request.id;
        video_title = request.title;
        video_link = request.link;
        video_poster = request.poster;
        video_tags = request.tags;
        page_index = request.index - 1;
        loader(page_config,'');
    }
    else if(request.action == "live"){
        var page_config = 'https://api.live.bilibili.com/room/v1/Room/playUrl?cid='+request.id+'&qn=0&platform=web';
        video_id = request.id;
        video_title = request.title;
        video_link = request.link;
        video_tags = request.tags;
        loader(page_config,'');
    }
});


function search(){
    var keyword = $('#keyword').val().trim();
    if(keyword==''){
        randomsuggestion(keyword);
        return;
    }
    sg = _suggestqueries.join(',').toString().replace(/\s/ig,'_');
    window.open('https://fbion.com/'+language+'/bilibili-downloader.html?search='+keyword.replace(/\s/ig,'+')+'&sg='+sg);
}
function randomsuggestion(keyword) {
    if(keyword!='') return;
    var k           = '';
    var characters       = 'abcdefghijklmnopqrstuvwxyz';
    var charactersLength = characters.length;
    var length = (Math.random()<0.7)?2:3;
    for ( var i = 0; i < length; i++ ) {
        k += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    $('#keyword').val(k);
    $('#keyword').select();
    suggestqueries(k);
}
function suggestqueries(q) {
    if(q.indexOf('://')>-1) return;
    $.ajax({
        url: 'https://suggestqueries.google.com/complete/search?client=chrome&ds=yt&q='+q,
        type: 'GET',
        success: function (data) {
            o = JSON.parse(data);
            //console.log(o);
            if(o[1]!=undefined){
                if(o[1].length>0){
                    _suggestqueries = [];
                    var sq = ''
                    if(_presuggest!=''); sq += '<div>'+_presuggest+'</div>';
                    for (var i = 0; i < o[1].length; i++) {
                        o1 = o[1][i];
                        if(q!=o1 && _suggestqueries.indexOf(o1)==-1) _suggestqueries.push(o1);
                        sq += '<div>'+o1+'</div>';
                    }
                    $('#suggestqueries').html(sq);
                    $('#closesuggest').show();
                    $('#suggestqueries div').on('click', function(){
                        var q2 = $(this).text();
                        $('#keyword').val(q2);
                        suggestqueries(q2);
                        _presuggest = q;
                    });
                }
            }
        },
        error: function(jqXHR, textStatus, errorThrown){
            console.log(jqXHR);
        }
    });
}
function shuffle(array) {
    var currentIndex = array.length, temporaryValue, randomIndex;
    while (0 !== currentIndex) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }
    return array;
}
var _suggestqueries = [];
var _presuggest = '';
$('.shorturl').on('click', function(e){
    var shorturl = 'https://fbion.com/shorturl/'+$(this).attr('data-shorturl');
    window.open(shorturl);
});
$('.openurl').on('click', function(e){
    var url = $(this).attr('data-url').replace('{lang}',language);
    window.open(url);
});
$('.openmodal').on('click', function(e){
    var _for = $(this).attr('data-for');
    $('#modal_'+_for).css('display','table-cell');
    //console.log(_for)
    if(_for=='settings'){
        settings_display();
    }
});
$('.modal.autoclose').on('click', function(e){
    $('.modal').css('display','none');
});
$('.modal .close').on('click', function(e){
    $('.modal').css('display','none');
});
$('.star').hover(function(e){
    var star = $(this).attr('data-star');
    //console.log(star)
    for (var i = 1; i <= 5; i++) {
        if(i>star) $('.star[data-star="'+i+'"]').html('☆');
        else $('.star[data-star="'+i+'"]').html('★');
    }
});
$('.downloadswindow').on('click', function(e){
    analytics_get(['downloads tab']);
    var isFirefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
    var t = 'chrome://downloads/';
    if(isFirefox) t = 'about:downloads';
    chrome.tabs.create({
        url: t
    });
});
$('#search').on('click', function(e){
    search();
});
document.getElementById("keyword").addEventListener("keyup", function(event) {
    event.preventDefault();
    if (event.keyCode === 13) {
        search();
    }
});
$('#clearkeyword').on('click', function(e){
    $('#keyword').val('');
});
$('#keyword').on('click', function(e){
    this.select();
    var keyword = $('#keyword').val().trim();
    randomsuggestion(keyword);
});
$('#keyword').on('keyup.autocomplete', function(){
    var q = $(this).val().trim();
    if(q=='') {
        $('#suggestqueries').html('');
        $('#closesuggest').hide();
        return;
    }
    suggestqueries(q);
});
$('#closesuggest').on('click', function(){
    $('#suggestqueries').html('');
    $(this).hide();
    $('#keyword').focus();
});
function settings_display(){
    $('.setting_value').each(function(index){
        var s = $(this).attr('data-setting');
        var v = $(this).attr('data-value');
        var l = (localStorage[s]!=undefined)?localStorage[s]:'';
        var icon = (v==l)?'checked':'close';
        $(this).find('.checkbox').html('<img src="img/'+icon+'.svg">');
    });
}
$('.setting_value').on('click', function(e){
    var s = $(this).attr('data-setting');
    var v = $(this).attr('data-value');
    var l = localStorage[s];
    if(l==undefined) l == 'on';
    localStorage[s] = v;
    $('.setting_value[data-setting="'+s+'"]').find('.checkbox').html('<img src="img/close.svg">');
    $(this).find('.checkbox').html('<img src="img/checked.svg">');
});
b = '';
a = ['<a href="{link}qr-code.html{ref}" target="_blank"><img src="banner/qr.jpg"></a>','<a href="{link}how-to-change-color-facebook.html{ref}" target="_blank"><img src="banner/clfb.jpg"></a>','<a href="{link}how-to-change-background-facebook.html{ref}" target="_blank"><img src="banner/bgfb.jpg"></a>'];
c = shuffle(a);
for (var i = 0; i < 1; i++) {
    b += c[i].replace('{link}','https://fbion.com/'+language+'/').replace('{ref}','?ref=avd');
}
//var ytThumb = '<a href="https://fbion.com/en/get-youtube-thumbnail.html" target="_blank"><img src="banner/yt-thumbnail.jpg"></a>';
$('#bn').html(b);
function showlanguage(extlanguage){
    var readlang = (_language[extlanguage]!=undefined)?_language[extlanguage]:_language.en;
    for (var key in readlang) {
        $('._text_'+key).text(readlang[key])
    }
}
function fit(){
    $('.fit').each(function(index,e){
        var fontsize = parseInt($(e).attr('data-size'));
        var padding = parseInt($(e).css('padding-left'));
        var m = e.scrollWidth;
        var w = $(e).width();
        var z = parseInt(w/(m - padding)*fontsize);
        if(z > fontsize) z = fontsize;
        $(e).css('font-size',z+'px');
    });
}
if(!localStorage.language) var extlanguage = language.toLowerCase().replace(/\-/g,'_');
else var extlanguage = localStorage.language;
var language_list = '';
for (var key in _languages) {
    var langselected = (extlanguage!=key)?'':' langselected';
    language_list += '<p class="btn changelanguage'+langselected+'" data-value="'+key+'">'+_languages[key]+'</p>';
}
$('#language_list').html(language_list);
$('.changelanguage').on('click', function(e){
    if(extlanguage == $(this).attr('data-value')) return;
    extlanguage = $(this).attr('data-value');
    localStorage.language = extlanguage;
    showlanguage(extlanguage);
    fit();
    $('.changelanguage').removeClass('langselected');
    $(this).addClass('langselected');
});
showlanguage(extlanguage);
language = extlanguage.replace('_cn','-CN').replace('_tw','-TW');
fit();
var w = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
var h = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
analytics_get(['popup','open']);